/* Ŀ
              TransMutationNumericSystem (TMNS)  tehnology             
                   Permutation CryptoAlgoritham - PCA                  
                      Timefors Secrallet Wortex 3.0                    
               Cryptografic System by Kostadin Bajalcaliev             
                                                                       
       All rights according to law of The Republic of Macedonia belong 
     to the author.  Any individual or institution have right to  use, 
     copy,or redistribute this software so long as all of the original 
     files are included unmodified,that it is not sold for profit, and 
     this copyright notice is retained.                                
                                                                       
        Cryptografic Routin Modul                         wrx3.c       
                                                                       
     (c) Kostadin Bajalcaliev 1997                                     
   */

 #include <stdio.h>
 #include <string.h>
 #include <dos.h>
 #include <conio.h>

  int a[255],n,b[255],c[255];
  int tm[256][8];
  int VV=0;

  void tMmaker(int cr);
  char *bin(int inp);
  void CryptFile(FILE *inf,FILE *outf,char *cod,int cr,int ppn);
  int debin(char *vv);
  int pow(int osn, int step);
  long ffsize(FILE *koj);

  int main (void)
   {
    FILE *inf,*outf;
    char cod[200];
    int g;
     printf("\n Ŀ");
     printf("\n                    Timefors Secrallet Wortex 3.0                    ");
     printf("\n              Encryption Utility by Kostadin Bajalcaliev             ");
     printf("\n                        Demonstration Program                        ");
     printf("\n                                                                     ");
     printf("\n     All rights according to law of The Republic of Macedonia belong ");
     printf("\n   to the author.  Any individual or institution have right to  use, ");
     printf("\n   copy,or redistribute this software so long as all of the original ");
     printf("\n   files are included unmodified,that it is not sold for profit, and ");
     printf("\n   this copyright notice is retained. Read Wortex.txt!!!             ");
     printf("\n \n");
     sleep(1); clrscr();

     printf("Vnesete ja shifrata:"); scanf("%s",&cod); clrscr();
     printf("0 za crypt, 1 za decrypt: "); scanf("%d",&g);
     CryptFile(stdin,stdout,cod,g,-1);
   }

  char *bin(int inp)
   {
    char *nbl="            ";
    const char *binn[]=
                   {"0000","0001","0010","0011","0100","0101","0110","0111",
                    "1000","1001","1010","1011","1100","1101","1110","1111"};
     strcpy(nbl,binn[(inp & 0xF0)>>4]);
     strcat(nbl,binn[inp & 0x0F]);
     return nbl;
   }


  int debin(char *vv)
   {
    int yy,vrv,yv;
     vrv=0;
     yv=strlen(vv)-1;
      for(yy=0;yy<=yv;yy++) vrv+=pow(2,yv-yy)*(vv[yy]-'0');
     return vrv;
   }

  int pow(int osn, int step)
   {
    int osnnstep, pi;
     osnnstep=1;
      for(pi=1;pi<=step;pi++) osnnstep*=osn;
     return osnnstep;
   }

  void CryptFile(FILE *inf,FILE *outf,char *cod,int cr,int ppn)
   {
    int cel,ost,i,a,b,len,fltr,prom,xi=1,yi=4,xo=1,yo=14;
    char nn[20];
    char res[16];
    char *rr="                                     ";
    const char *nib3[]={"000","001","010","011","100","101","110","111"};
    long index, gran; /* zaradi zgolemuvanje na brzinata pospoin() kje se
                        povikuva so frekfentnost file_size/1000 */
     tMmaker(cr);
     gran=ffsize(inf)/1000; index=0;
/*     fseek(inf,0,SEEK_SET);
     fseek(outf,0,SEEK_SET);*/
     fltr=0;
      for(i=0;i<strlen(cod);i++) fltr^=cod[i];
/*      if(ppn==-1) printf("\n");*/
     nn[0]=0; res[0]=0; rr[0]=0; b=-1; len=strlen(cod);
     prom=0;
      while(!feof(inf))
       {
	gotoxy(xi,yi);
         if(cr)
	  rr=bin(getche()^fltr);
         else
	  rr=bin(getche()^fltr^0xFF);
	xi=wherex(); yi=wherey();
         if(feof(inf)) break;
        index++;
        strcat(res,rr);
        cel=strlen(res)/3;
        ost=strlen(res)%3;
         for(i=0;i<cel;i++)
          {
           rr[0]=res[i*3];
           rr[1]=res[i*3+1];
           rr[2]=res[i*3+2];
           rr[3]=0;
           b++;
           if(b==len) b=0;
           strcat(nn,nib3[tm[cod[b]][debin(rr)]]);
          }
         for(i=0;i<ost;i++) res[i]=res[cel*3+i];
        res[ost]=0;
        cel=strlen(nn)/8;
        ost=strlen(nn)%8;

	/* if(ppn==-1 && cel && index>=gran)
          {
	  gotoxy(1,wherey());
           printf(" Progress Indicator: %d %%      ",prom/10);
           index=0;
           prom++;
	  }  */

         for(i=0;i<cel;i++)
          {
           a=i*8;
           rr[0]=nn[a+0];
           rr[1]=nn[a+1];
           rr[2]=nn[a+2];
           rr[3]=nn[a+3];
           rr[4]=nn[a+4];
           rr[5]=nn[a+5];
           rr[6]=nn[a+6];
           rr[7]=nn[a+7];
	   rr[8]=0;
	   gotoxy(xo,yo);
            if(cr)
	     printf("%c",debin(rr)^fltr^0xFF);
            else
	     printf("%X(%d) ",debin(rr)^fltr,debin(rr)^fltr);
	   xo=wherex(); yo=wherey();
          }
         for(i=0;i<ost;i++) nn[i]=nn[cel*8+i];
        nn[ost]=0;
       }
     gotoxy(xo,yo);
      if(strlen(nn)) { strcat(nn,res);  if(cr)
                                         { fputc(debin(nn)^fltr^0xFF,outf); }
                                        else
                                         { fputc(debin(nn)^fltr,outf); } }
     fclose(inf); fclose(outf);
/*     gotoxy(10,1); printf(" Progress Indicator: 100 %% \n");*/
   }

  void tMmaker(int cr)
   {
    int j=0,p=0,l=0,y=0,f=0,w=1;
     n=8;
      for(j=0;j<255;j++) { a[j]=0; b[j]=0; c[j]=0; tm[j][0]=0; }
     a[n-1]=1;
     VV=0;
      while(!a[n])
       {
         for(j=1;j<=n-1;j++)
          if(a[j]>j) { a[j+1]++; a[j]=0; }
        p=0;
         for(j=n-1;j>=0;j--)
          {
           p=a[j]+1;  y=0; l=0;
            for(l=0;l<=n-1;l++)
             {
              if(b[l]==0) y++;
              if(y==p) { c[j]=l; b[l]=1; l=n; }
             }
          }
        w=1;
         for(f=n-1;f>0 && w;f--)
          {
           w=0;
            if(c[f-1]!=c[f]+1 && c[f-1]!=c[f]-1 &&
               c[f]+1!=n-f    && c[f]+1!=f+1) w=1;
          }
         if(VV>244 && VV<256 && w && c[0]+1!=n && c[0]+1!=1) goto hk;
         if(c[0]+1==n || c[0]+1==1 || c[0]<c[n-1]) w=0;
     hk: if(w && !cr) { for(f=0;f<n;f++) tm[VV][f]=c[f]; VV++; }
         if(w && cr) { for(f=0;f<n;f++) tm[VV][c[f]]=f; VV++; }
         for(j=0;j<=n;j++) { b[j]=0; c[j]=0; }
        a[1]++;
       }
   }

  long ffsize(FILE *koj)
   {
    long posb,pose;
     posb=ftell(koj);
     fseek(koj,0,SEEK_END);
     pose=ftell(koj);
     fseek(koj,posb,SEEK_SET);
     return pose;
   }


