/* Ŀ
              TransMutationNumericSystem (TMNS)  tehnology             
                      Timefors Secrallet Wortex 3.0                    
               Cryptografic System by Kostadin Bajalcaliev             
                                                                       
       All rights according to law of The Republic of Macedonia belong 
     to the author.  Any individual or institution have right to  use, 
     copy,or redistribute this software so long as all of the original 
     files are included unmodified,that it is not sold for profit, and 
     this copyright notice is retained.                                
                                                                       
        Graphic Interface Modul Surce Cod File       intrface.cc       
                                                                       
     (c) Kostadin Bajalcaliev 1997                                     
   */

 #include "intrface.h"

  void wind(int topx,int topy,int botx,int boty,
            int color1,int color2,int color3,int deb)
   {
    int _i;
     setfillstyle(SOLID_FILL,color3);
      for(_i=1;_i<=deb;_i++)
       {
        setcolor(color1);
        moveto(topx+_i,boty-_i);
        lineto(topx+_i,topy+_i);
        lineto(botx-_i,topy+_i);
        setcolor(color2);
        lineto(botx-_i,boty-_i);
        lineto(topx+_i,boty-_i);
       }
     if(color3!=-1) bar(topx+_i,topy+_i,botx-_i,boty-_i);
   }

  int initgraphic(void)
   {
    int gdriver=VGA, gmode=VGAHI, errorcode;
     registerbgidriver(EGAVGA_driver);
     registerbgifont(triplex_font);
     registerbgifont(small_font);
     initgraph(&gdriver, &gmode, "");
     errorcode = graphresult();
                if (errorcode != grOk)
       {
        printf("Graphics error: %s\n", grapherrormsg(errorcode));
        printf("Press any key to halt:");
        getch();
        exit(1);
       }
     return 0;
   }


  void SetPalette(void)
   {
    struct palettetype pal;
     setfillstyle(SOLID_FILL,RED);
     getpalette(&pal);
/*     setrgbpalette(pal.colors[0],0,0,168);*/
     setrgbpalette(pal.colors[1],255,255,0);
     setrgbpalette(pal.colors[2],0,0,20);
     setrgbpalette(pal.colors[3],0,0,250);
     setrgbpalette(pal.colors[4],0,0,168);
     setrgbpalette(pal.colors[5],30,30,30);
     setrgbpalette(pal.colors[6],0,0,95);
     setrgbpalette(pal.colors[14],0,0,0);
     setrgbpalette(pal.colors[8],255,0,0);
     setrgbpalette(pal.colors[9],160,160,160);
     setrgbpalette(pal.colors[15],255,255,255);
/*     setrgbpalette(pal.colors[11],0,0,255);*/
   }


  int wwindow(int topx,int topy,int botx,int boty)
   {
     fmkord();
     tip[mkord]=1;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=botx;
     kord[mkord][3]=boty;
     kord[mkord][4]=3;
     kord[mkord][5]=2;
     kord[mkord][6]=4;
     kord[mkord][7]=2;
     return mkord;
   }

  int windoww(int topx,int topy,int botx,int boty,
              int color1,int color2,int color3,int deb)
   {
     fmkord();
     tip[mkord]=1;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=botx;
     kord[mkord][3]=boty;
     kord[mkord][4]=color1;
     kord[mkord][5]=color2;
     kord[mkord][6]=color3;
     kord[mkord][7]=deb;
     return mkord;
   }

  int botton(int topx,int topy,char *text)
   {
     fmkord();
     tip[mkord]=3;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=topx+80;
     kord[mkord][3]=topy+40;
     kord[mkord][4]=0; /* push */
     kord[mkord][5]=getfont();
     kord[mkord][6]=getsize();
     kord[mkord][7]=0; /* push */
     strcpy(textt[mkord],text);
     return mkord;
   }

  int push(int koj)
   {
      if(tip[koj]==3) kord[koj][4]=1;
     return koj;
   }

  int ispush(int koj)
   {
      if(tip[koj]==3) return kord[koj][7];
     return 0;
   }

  void boton(int pnp, int topx, int topy, int botx, int boty, char *text)
   {
     pnp%=2;
      if(pnp)
        wind(topx,topy,botx,boty,2,3,4,2);
       else
        wind(topx,topy,botx,boty,3,2,4,2);
      setcolor(1);
      settextjustify(1,1);
      outtextxy(topx+(botx-topx)/2+2*pnp,
                topy+(boty-topy)/2+2*pnp,text);
      settextjustify(0,2);
   }

  int botonn(int topx, int topy, int botx, int boty, char *text)
   {
     fmkord();
     tip[mkord]=3;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=botx;
     kord[mkord][3]=boty;
     kord[mkord][4]=0;
     kord[mkord][5]=getfont();
     kord[mkord][6]=getsize();
     kord[mkord][7]=0; /*psh*/
     strcpy(textt[mkord],text);
     return mkord;
   }

  int textwin(int topx,int topy,int dolzina,char *text)
   {
     fmkord();
     tip[mkord]=2;
     view[mkord]=0;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=topx+dolzina+textwidth(text);
     kord[mkord][3]=topy+20;
     kord[mkord][4]=topx+10+textwidth(text);
     kord[mkord][5]=topy+(20-textheight(text))/2;
     kord[mkord][6]=dolzina;
     kord[mkord][7]=1; /* bojatext */
     kord[mkord][8]=7; /* bojapoz */
     kord[mkord][9]=14;  /* baja na text vo textwin */
     strcpy(textt[mkord],text);
     return mkord;
   }

  void txtwin(int topx,int topy,int botx,int boty,char *text,
              int bojapoz, int bojatext)
   {
     setcolor(bojatext);
     outtextxy(topx,topy+(boty-topy-textheight(text))/2,text);
     wind(topx+textwidth(text),topy,botx,boty,2,3,bojapoz,2);
   }

  void fmkord(void)
   {
    mkord=1;
      while(tip[mkord]!=0) mkord++;
   }

  int puttitle(int kade,char *text)
   {
      if(tip[kade]!=1) return 0;
     fmkord();
     tip[mkord]=4;
     kord[mkord][0]=kord[kade][0]+3;
     kord[mkord][1]=kord[kade][1]+3;
     kord[mkord][2]=kord[kade][2]-3;
     kord[mkord][3]=kord[kade][1]+22;
     strcpy(textt[mkord],text);
     return mkord;
   }

  void delobj(void,...)
   {
    va_list ap;
    int koj,ij;
     va_start(ap, void);
      while((koj = va_arg(ap,int))!=-1)
       {
        setfillstyle(SOLID_FILL,4);
         for(ij=1;ij<50;ij++)
          {
            if(tip[ij] &&
               kord[ij][0]>=kord[koj][0] &&
               kord[ij][1]>=kord[koj][1] &&
               kord[ij][2]<=kord[koj][2] &&
               kord[ij][3]<=kord[koj][3] ) { unvwobj(ij); tip[ij]=0; }
            if(koj==-1) { unvwobj(ij); tip[ij]=0; }
          }
       }
     va_end(ap);
   }

  void unvwobj(int koj)
   {
    int _i;
     setfillstyle(SOLID_FILL,4);
      for(_i=1;_i<50;_i++)
       {
         if(tip[_i] &&
           kord[_i][0]>=kord[koj][0] &&
           kord[_i][1]>=kord[koj][1] &&
           kord[_i][2]<=kord[koj][2] &&
           kord[_i][3]<=kord[koj][3] ) view[_i]=0;
         if(koj==-1)
          {
           view[_i]=0;
           bar(kord[koj][0],kord[koj][1],kord[koj][2],kord[koj][3]);
          }
       }
     bar(kord[koj][0],kord[koj][1],kord[koj][2],kord[koj][3]);
   }

  int getkey(int mod)
   {
    int key,lo,hi;
      switch(mod)
       {
        case 1: if(kbhit()) key = bioskey(0); else key=0; break;
        case 0: key=bioskey(0); break;
       }
     lo = key & 0X00FF;
     hi = (key & 0XFF00) >> 8;
     return((lo == 0) ? hi + 256 : lo);
   }

  int gprintf( int kade, char *fmt, ... )
   {
    va_list  argptr;
    char str[140];
    int cnt;
     settextjustify(0,2);
      if(tip[kade]!=2 || view[kade]==0) return 0;
     setviewn();
     clrtxwn(kade);
     setviewport(kord[kade][4]-5,kord[kade][1]+3,kord[kade][2]-3,kord[kade][3]-3,1);
     moveto(0,4);
     setcolor(kord[kade][9]);
     unviewm();
     va_start( argptr, fmt );
      cnt=vsprintf( str, fmt, argptr );
      outtext(str);
     va_end( argptr );
     setviewn();
     viewm();
     return ( cnt );
   }

  int ramka(int topx,int topy,int botx,int boty)
   {
     fmkord();
     tip[mkord]=5;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=botx;
     kord[mkord][3]=boty;
     return mkord;
   }

  int clrtxwn(int koj)
   {
      if(tip[koj]!=2) return 0;
     mkord=koj;
     unviewm();
     setviewn();
     wind(kord[mkord][0]+textwidth(textt[mkord]),
          kord[mkord][1],
          kord[mkord][2],
          kord[mkord][3],2,3,
          kord[mkord][8],2);
     viewm();
     return 0;
   }

  int pushb(int koj)
   {
      if(tip[koj]==3)
       {
        kord[koj][4]=1;
        vwobj(koj);
        delay(zg*1000);
        vwobj(koj);
       }
     return koj;
   }

  int vwobj(int koj)
   {
     mkord=koj;
     setviewn();
      if(!tip[koj]) return 0;
     view[koj]=1;
     unviewm();
      switch(tip[koj])
       {
        case 1: wind(kord[mkord][0],kord[mkord][1],kord[mkord][2],
                     kord[mkord][3],kord[mkord][4],kord[mkord][5],
                     kord[mkord][6],kord[mkord][7]);
                break;
        case 2: txtwin(kord[mkord][0],kord[mkord][1],kord[mkord][2],
                       kord[mkord][3],textt[mkord],kord[mkord][8],
                       kord[mkord][7]);
                break;
        case 3: settextstyle(kord[mkord][5],0,kord[mkord][6]);
                boton(kord[mkord][4],kord[mkord][0],kord[mkord][1],
                      kord[mkord][2],kord[mkord][3],textt[mkord]);
                kord[mkord][7]=kord[mkord][4]; kord[mkord][4]=0;
                break;
        case 4: wind(kord[mkord][0]+1,kord[mkord][1]+1,kord[mkord][2]-1,
                     kord[mkord][3]-1,6,6,6,1);
                setcolor(15);
                settextjustify(0,2);
                outtextxy(kord[mkord][0]+9,
                          kord[mkord][1]+(20-textheight(textt[mkord]))/2,
                          textt[mkord]);
                break;
        case 5: wind(kord[mkord][0],kord[mkord][1],kord[mkord][2],
                     kord[mkord][3],2,3,-1,1);
                wind(kord[mkord][0]+1,kord[mkord][1]+1,kord[mkord][2]-1,
                     kord[mkord][3]-1,3,2,-1,1);
                break;
        case 6: wind(kord[mkord][0],kord[mkord][1],kord[mkord][2],
                     kord[mkord][3],2,3,kord[mkord][7],2);
                pospoin(mkord,0);   break;
       }
     viewm();
     return koj;
   }


  int initpoin(unsigned long gran,int topx,int topy,int dolzina)
   {
     fmkord();
     tip[mkord]=6;
     kord[mkord][0]=topx;
     kord[mkord][1]=topy;
     kord[mkord][2]=topx+dolzina+10;
     kord[mkord][3]=topy+26;
     poing[mkord]=gran;
     kord[mkord][5]=0; /* 0% */
     kord[mkord][6]=dolzina;
     kord[mkord][7]=7; /* bojapoz */
     return mkord;
   }

  int pospoin(int koj, unsigned long vred)
   {
    float pom;
      if(tip[koj]!=6 && view[koj]) return 2;
      if(vred>poing[koj] && kord[koj][5]<1000)
        { vred=poing[koj]; }
       else
        { if(vred>poing[koj]) { kord[koj][5]=1001; return 1; } }
     pom=1000*(float)vred/poing[koj];
      if((int)pom/10>kord[koj][5]/10)
       {
        settextjustify(1,1);
        setcolor(kord[koj][7]);
        gprintff(kord[koj][0]+(kord[koj][2]-kord[koj][0])/2,
                 kord[koj][1]+(kord[koj][3]-kord[koj][1])/2,
                 "%d %",kord[koj][5]/10);
      }
     kord[koj][5]=(int)pom;
     setfillstyle(SOLID_FILL,4);
     pom=((float)kord[koj][6]/1000)*(float)kord[koj][5];
     setfillstyle(SOLID_FILL,3);
      if(pom) bar(kord[koj][0]+5,kord[koj][1]+5,
                  kord[koj][0]+(int)pom+5,
                  kord[koj][3]-5);
     settextjustify(1,1);
     setcolor(1);
     gprintff(kord[koj][0]+(kord[koj][2]-kord[koj][0])/2,
              kord[koj][1]+(kord[koj][3]-kord[koj][1])/2,
              "%d %",kord[koj][5]/10);
     return 0;
   }


  int isitin(int objbr,int mkey)
   {
      if( getmouse(mkey)==mkey && mouse.xx>kord[objbr][0] &&
                                  mouse.xx<kord[objbr][2] &&
                                  mouse.yy>kord[objbr][1] &&
                                  mouse.yy<kord[objbr][3]) return 1;
     return 0;
   }

  int getfont(void)
   {
     gettextsettings(&tt);
     return tt.font;
   }

  int getsize(void)
   {
     gettextsettings(&tt);
     return tt.charsize;
   }

  int setview(int p1,int p2,int p3,int p4,int p5)
   {
/*     getviewsettings(&vw);                           */
     vw.left=p1; vw.top=p2; vw.right=p3; vw.bottom=p4; vw.clip=p5;
     setviewport(p1,p2,p3,p4,p5);
     return 0;
   }


  int setviewb(void)
   {
     setviewport(vw.left,vw.top,vw.right,vw.bottom,vw.clip);
     return 0;
   }

  int setviewn(void)
   {
     setviewport(0,0,getmaxx(),getmaxy(),1);
     return 0;
   }



 int gscanf(int kade,char *fmt, ...)
   {
    int ff,gk,_x;
    va_list argptr;
    char buffer[200],buf[1];
      if(tip[kade]!=2 || !view[kade]) return 9;
     clrtxwn(kade);
     setview(kord[kade][4]-5,kord[kade][1]+3,kord[kade][2]-3,kord[kade][3]-3,1);
     _x=kord[kade][2]-2-kord[kade][4]+5;
     settextjustify(0,2);
     moveto(0,4);
     setcolor(14);
     strcpy(buf," ");
     strcpy(buffer,"");
     ff=0;
     gk=getkey(1); getmouse(1);

      while(gk!=13 && !mouse.left)
       {
pak:     if(gk==8)
          {
            if(ff>0)
             {
              ff--;
              buffer[ff]=0;
               if(ff<=_x/textwidth("H")-1)
                {
                  setcolor(7);
                  outtextxy(getx()-textwidth("H"),gety(),"");
                  moveto(getx()-textwidth("H"),gety());
                  setcolor(0);
                }
             }
           gk=getkey(1); if(gk==13) goto skok;
           goto pak;
          }
         if(gk!=256)
          {
           buf[0]=(char)gk; strcat(buffer,buf);
            if(getx()<=_x-textwidth("H")) outtext(buf);
           ff++;
          }
skok:    gk=getkey(1);
        getmouse(1);
       }
     va_start(argptr, fmt);
      vsscanf(buffer, fmt, argptr);
     va_end(argptr);
     setviewn();
     return 0;
   }

  int gprintff( int xloc, int yloc, char *fmt, ... )
   {
    va_list  argptr;
    char str[140];
    int cnt;
     unviewm();
     va_start( argptr, fmt );
      cnt = vsprintf( str, fmt, argptr );
      outtextxy( xloc, yloc, str );
     va_end( argptr );
     viewm();
     return( cnt );
   }

  int clrvw(int color)
   {
    struct viewporttype vww;
     getviewsettings(&vww);
     setfillstyle(SOLID_FILL,color);
     bar(0,0,vww.right-vww.left,vww.bottom-vww.top);
     return 0;
   }

  void clrdv(void)
   {
     unviewm();
     cleardevice();
     viewm();
   }

